commit 2aa4400cb9830da0a335a8cbb75183706714b28d
Author: Jason Merrill <jason@redhat.com>
Date:   Thu Jan 6 01:39:48 2022

    c++: when delegating constructor throws [PR103711]
    
    We were always calling the complete destructor if the target constructor
    throws, even if we were calling the base constructor.
    
            PR c++/103711
    
    gcc/cp/ChangeLog:
    
            * init.c (perform_target_ctor): Select destructor by in_chrg.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/eh/delegating1.C: New test.

diff --git a/gcc/cp/init.c b/gcc/cp/init.c
index 3c4aa5846d6..c73afc08f04 100644
--- a/gcc/cp/init.c
+++ b/gcc/cp/init.c
@@ -541,6 +541,16 @@ perform_target_ctor (tree init)
 				|LOOKUP_NONVIRTUAL
 				|LOOKUP_DESTRUCTOR,
 				0, tf_warning_or_error);
+      if (DECL_HAS_IN_CHARGE_PARM_P (current_function_decl))
+	{
+	  tree base = build_delete (input_location,
+				    type, decl, sfk_base_destructor,
+				    LOOKUP_NORMAL
+				    |LOOKUP_NONVIRTUAL
+				    |LOOKUP_DESTRUCTOR,
+				    0, tf_warning_or_error);
+	  expr = build_if_in_charge (expr, base);
+	}
       if (expr != error_mark_node
 	  && TYPE_HAS_NONTRIVIAL_DESTRUCTOR (type))
 	finish_eh_cleanup (expr);
diff --git a/gcc/testsuite/g++.dg/eh/delegating1.C b/gcc/testsuite/g++.dg/eh/delegating1.C
new file mode 100644
index 00000000000..c33374a3b6b
--- /dev/null
+++ b/gcc/testsuite/g++.dg/eh/delegating1.C
@@ -0,0 +1,28 @@
+// PR c++/103711
+// { dg-do run { target c++11 } }
+
+int constructions = 0;
+int destructions = 0;
+
+struct A
+{
+  A() { constructions++; }
+  virtual ~A() { destructions++; }
+};
+
+struct B : public virtual A
+{
+  B(int) { }
+  B() : B(1) { throw -1; }
+  virtual ~B() = default;
+};
+
+struct C : public B { };
+
+int main() {
+  try {
+    C c;
+  }
+  catch (int) {}
+  return (constructions - destructions);
+}

